#include "DummyProgressListener.h"
#include "nsIDOMWindow.h"
#include "nsIDOMHtmlDocument.h"
#include "nsIWebProgress.h"
#include "MyComponent.h"
#include "nsComponentManagerUtils.h"
#include "nsIDOMHTMLElement.h"


NS_IMPL_ISUPPORTS2(DummyProgressListener,nsISupportsWeakReference,nsIWebProgressListener);

NS_IMETHODIMP DummyProgressListener::OnStateChange(nsIWebProgress *aWebProgress, nsIRequest *aRequest, PRUint32 aStateFlags, nsresult aStatus)
{
	nsresult rv = NS_OK;
	if (aStateFlags & nsIWebProgressListener::STATE_IS_DOCUMENT) 
	{
		if(aStateFlags & nsIWebProgressListener::STATE_STOP){
			nsCOMPtr<nsIDOMWindow> spDomWindow;
			aWebProgress->GetDOMWindow(getter_AddRefs(spDomWindow));
			nsCOMPtr<nsIDOMDocument> pDomDoc;
			spDomWindow->GetDocument(getter_AddRefs(pDomDoc));
			nsCOMPtr<nsIDOMHTMLDocument> pHtmlDoc = do_QueryInterface(pDomDoc);
			if(pHtmlDoc){
				nsCOMPtr<nsIDOMHTMLElement> pBodyElem;
				pHtmlDoc->GetBody(getter_AddRefs(pBodyElem));
				nsCOMPtr<IObj> pTmpCtrl = do_CreateInstance(MY_COMPONENT_CONTRACTID);
				PRInt32 retVal; 
				pTmpCtrl->Foo(pBodyElem,&retVal);
			}
		}
	}
	return rv;
}

NS_IMETHODIMP DummyProgressListener::OnProgressChange(nsIWebProgress *aWebProgress, nsIRequest *aRequest, PRInt32 aCurSelfProgress, PRInt32 aMaxSelfProgress, PRInt32 aCurTotalProgress, PRInt32 aMaxTotalProgress)
{
	return NS_OK;
}

NS_IMETHODIMP DummyProgressListener::OnLocationChange(nsIWebProgress *aWebProgress, nsIRequest *aRequest, nsIURI *aLocation)
{
	return NS_OK;
}

NS_IMETHODIMP DummyProgressListener::OnStatusChange(nsIWebProgress *aWebProgress, nsIRequest *aRequest, nsresult aStatus, const PRUnichar *aMessage)
{
	return NS_OK;
}

NS_IMETHODIMP DummyProgressListener::OnSecurityChange(nsIWebProgress *aWebProgress, nsIRequest *aRequest, PRUint32 aState)
{
	return NS_OK;
}
