#include "MyComponent.h"
#include "nsCOMPtr.h"
#include "nsIDOMHTMLElement.h"
#include "nsServiceManagerUtils.h"
#include "mozIJSSubScriptLoader.h"
#include "WrapScriptEngine.h"
#include "nsMemory.h"
#include "nsComponentManagerUtils.h"
#include "nsIDOMElement.h"
#include "DummyProgressListener.h"
#include "nsIWebProgress.h"


NS_IMPL_ISUPPORTS2(CMyComponent,IObj,nsIObserver);
nsCOMPtr<nsIWebProgressListener> CMyComponent::m_dummyProgress;

CMyComponent::CMyComponent(void)
{
}

CMyComponent::~CMyComponent(void)
{
}

namespace{
	nsCOMPtr<nsIVariant> CreateNSVARFromElem(nsIDOMElement *e)
	{
		nsCOMPtr<nsIWritableVariant> nsVar = do_CreateInstance("@mozilla.org/variant;1");
		nsCOMPtr<nsISupports> nsElem = do_QueryInterface(e);
		nsVar->SetAsISupports(nsElem);
		return do_QueryInterface(nsVar);
	}

	nsCOMPtr<nsIDOMElement> GetElementFromNSVAR(nsIVariant *nsVar)
	{
		nsCOMPtr<nsIVariant> pnsVar = nsVar;
		nsCOMPtr<nsIDOMElement> res;
		PRUint16 type = nsIDataType::VTYPE_EMPTY;
		pnsVar->GetDataType(&type);
		switch(type)
		{
		case nsIDataType::VTYPE_INTERFACE:
		case nsIDataType::VTYPE_INTERFACE_IS:
			{
				nsCOMPtr<nsISupports> nsPtr;
				pnsVar->GetAsISupports(getter_AddRefs(nsPtr));
				res = do_QueryInterface(nsPtr);
			}
			break;
		}
		return res;
	}
	

}

NS_IMETHODIMP CMyComponent::Foo(nsISupports *element, PRInt32 *_retval)
{
	nsCOMPtr<nsIDOMElement> e = do_QueryInterface(element);
	nsresult nsHR;
	nsCOMPtr<IJSObj> jsObj = do_CreateInstance("@dummy.com/dummyJSObject;1",&nsHR);
	nsCOMPtr<nsIVariant> param = CreateNSVARFromElem(e);
	nsCOMPtr<nsIVariant> retVal;
	if(jsObj == NULL)
		return NS_ERROR_FAILURE;

	_ASSERT(jsObj != NULL);
	jsObj->FooJS(param,getter_AddRefs(retVal));
	if(retVal == NULL)
		return NS_ERROR_FAILURE;

	e = GetElementFromNSVAR(retVal);
	param = CreateNSVARFromElem(e);
	retVal = nsnull;
	jsObj->FooJS(param,getter_AddRefs(retVal));
	return NS_OK;
}

#define NS_DOCUMENTLOADER_SERVICE_CID   \
 { 0x057b04d0, 0x0ccf, 0x11d2,{0xbe, 0xba, 0x00, 0x80, 0x5f, 0x8a, 0x66, 0xdc}}


NS_IMETHODIMP CMyComponent::Observe(nsISupports *aSubject, const char *aTopic, const PRUnichar *aData)
{
	nsresult rv;
	NS_DEFINE_IID(kDocLoaderServiceCID, NS_DOCUMENTLOADER_SERVICE_CID);
	nsCOMPtr<nsIWebProgress> progress = do_GetService(kDocLoaderServiceCID,&rv);
	NS_ENSURE_TRUE(NS_SUCCEEDED(rv) && progress, rv);
	if(m_dummyProgress == nsnull)
		m_dummyProgress = new DummyProgressListener;

	return progress->AddProgressListener(m_dummyProgress, nsIWebProgress::NOTIFY_STATE_DOCUMENT);
}