#include "nsIGenericFactory.h"
#include "MyComponent.h"
#include "nsIComponentManager.h"
#include "nsICategoryManager.h"
#include "nsIServiceManager.h"
#include "nsIFile.h"
#include "nsCOMPtr.h"
#include "nsMemory.h"

static NS_METHOD MzCoreRegistrar(nsIComponentManager *aCompMgr,nsIFile*, const char*,const char*,const nsModuleComponentInfo*)
{
    nsresult rv = NS_OK;

	nsCOMPtr<nsIServiceManager> spServMgr = do_QueryInterface((nsISupports*)aCompMgr);
	NS_ENSURE_TRUE(spServMgr, NS_ERROR_FAILURE);

	nsCOMPtr<nsICategoryManager> spCatMgr;
	rv = spServMgr->GetServiceByContractID(NS_CATEGORYMANAGER_CONTRACTID,NS_GET_IID(nsICategoryManager),getter_AddRefs(spCatMgr));
	NS_ENSURE_TRUE(NS_SUCCEEDED(rv) && spCatMgr , rv); 

    rv = spCatMgr->AddCategoryEntry("app-startup", "SampleFFAddon Observer Startup",MY_COMPONENT_CONTRACTID,PR_TRUE, PR_TRUE, nsnull);
    NS_ENSURE_SUCCESS(rv,rv);
    return rv;

}

NS_GENERIC_FACTORY_CONSTRUCTOR(CMyComponent)

static nsModuleComponentInfo components[] =
{
	{
		MY_COMPONENT_CLASSNAME, 
			MY_COMPONENT_CID,
			MY_COMPONENT_CONTRACTID,
			CMyComponentConstructor,
			MzCoreRegistrar

	}
};

NS_IMPL_NSGETMODULE(SimpleFFAddon, components);

