/***********************************************************
constants
***********************************************************/

// reference to the interface defined in WrapScriptEngine.idl
const IJSObj = Components.interfaces.IJSObj;

// reference to the required base interface that all components must support
const nsISupports = Components.interfaces.nsISupports;

// UUID uniquely identifying our component
const CLASS_ID = Components.ID("{D5AB1179-9B04-4ea6-9A99-C990A6FA4DA2}");

// description
const CLASS_NAME = "Dummy Example JS XPCOM";

// textual unique identifier
const CONTRACT_ID = "@dummy.com/dummyJSObject;1";

/***********************************************************
class definition
***********************************************************/

//class constructor
function Dummy() {
}

// class definition
Dummy.prototype = {
  // define the function we want to expose in our interface
  FooJS: function(elem) {
    if(elem)
        return elem.wrappedJSObject.parentNode;
  },
  //nsISupports  
  QueryInterface: function(aIID)
  {
    Components.utils.reportError(IJSObj);
    if (!aIID.equals(IJSObj) &&    
        !aIID.equals(nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    if(aIID.equals(IJSObj))
        Components.utils.reportError("moshe");
    return this;
  }
};

/***********************************************************
class factory

This object is a member of the global-scope Components.classes.
It is keyed off of the contract ID. Eg:

myHelloWorld = Components.classes["@dietrich.ganx4.com/helloworld;1"].
                          createInstance(Components.interfaces.nsIHelloWorld);

***********************************************************/
var DummyFactory = {
  createInstance: function (aOuter, aIID)
  {
    if (aOuter != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    return (new Dummy()).QueryInterface(aIID);
  }
};

/***********************************************************
module definition (xpcom registration)
***********************************************************/
var DummyModule = {
  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, 
        CONTRACT_ID, aFileSpec, aLocation, aType);
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);        
  },
  
  getClassObject: function(aCompMgr, aCID, aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return DummyFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};

/***********************************************************
module initialization

When the application registers the component, this function
is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return DummyModule; }
